#!/usr/bin/perl -w
require 5.002;
use strict;
use Socket;
use FileHandle;
my ($ask, $remote,$port, $iaddr, $paddr, $proto, $line);

$ask = shift || 10;
$remote  = shift || 'localhost';
$port    = shift || 21;  # random port
if ($port =~ /\D/) { $port = getservbyname($port, 'tcp') }
die "No port" unless $port;
$iaddr   = inet_aton($remote)               || die "no host: $remote";
$paddr   = sockaddr_in($port, $iaddr);

$proto   = getprotobyname('tcp');
socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
connect(SOCK, $paddr)    || die "connect: $!";

SOCK->autoflush();
while (defined($line = <SOCK>)) {
    $_ = $line;
    chomp;
    if (m/(\d+) (.+)$/) {
	my($ret) = $1;
	if ($ret == 220) {
	    print SOCK "USER mpeuhuri\r\n";
	} elsif ($ret == 331) {
	    print SOCK "PASS Qm11aUfyj\r\n";
	} elsif ($ret == 227) {	# entering passive mode
	    if (m/(\d+) .*\(([0-9,]+)\)/) {
		my(@addr) = split /,/, $2;
		my($port) = $addr[4]*256+$addr[5];
		my(@ip) = @addr[0..3];
		printf "%d\t%s\t%d\n", time, join(".", @ip), $port;
		$ask --;
	    }
	    sleep 1;
	    if ($ask > 0) {
		print SOCK "PASV\r\n";
	    } else {
		print SOCK "QUIT\r\n";
	    }
	    next;			# do not print here
	} elsif ($ret == 221) {
	    last;
	} elsif ($ret > 500) {
	    print $_, "\n";
	    last;	    
	} else {
	    print SOCK "PASV\r\n";
	}
	printf "%d: %s\n", $ret, $2;
    } else {
	print $_, "\n";
    }
}

close (SOCK)            || die "close: $!";
exit;
